#!/bin/bash
echo
echo "Starting Database repair LEVEL 2 on `cat /RouletteMaster/ROULETTE_NAME` /data/ROULETTE_DATA.GDB"
echo "Press CTRL+C to cancel now...."
sleep 5
echo "Started...please wait(this process may last up to 30 minutes)."
echo "!!!DO NOT INTERRUPT THIS PROCESS!!!"


service crond stop > /dev/null 2>&1
service roulette stop > /dev/null 2>&1
service firebird stop > /dev/null 2>&1

sleep 10

#rm -rf /data/TEMPDB.GDB > /dev/null 2>&1
rm -rf /data/TEMPBKP.GBK > /dev/null 2>&1


BKPDB=`mktemp /data/ROULETTE_DATA.XXX`;
#if [ ! -e $BKPDB ]; then
    mv /data/ROULETTE_DATA.GDB $BKPDB
    if [ $? -ne 0 ]; then
	echo "ERROR: Error renaming database /data/ROULETTE_DATA.GDB to $BKPDB"
	exit 1
    fi
    echo "Old database renamed to $BKPDB."
    cp /RouletteMaster/EMPTY_DATABASE/ROULETTE_NEW.GDB /data/ROULETTE_DATA.GDB
    if [ $? -ne 0 ]; then
	echo "ERROR: Error copying new database from /RouletteMaster/EMPTY_DATABASE/ROULETTE_NEW.GDB to /data/ROULETTE_DATA.GDB"
	exit 2
    fi
    echo "New database copied to /data/ROULETTE_DATA.GDB"

    chmod 666 /data/ROULETTE_DATA.GDB
    chown firebird:firebird /data/ROULETTE_DATA.GDB
    if [ $? -ne 0 ]; then
	echo "ERROR: Error setting permission to /data/ROULETTE_DATA.GDB"
	exit 3
    fi
    echo "Database permission set to 666 and owned by firebird."
    
    /sbin/service firebird start
    sleep 5                       
    
    TABLE_NAME=DIGITAL_COUNTERS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=CONFIGURATION
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
   # TABLE_NAME=CREDIT_TRANSFERS
   # fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
   # fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=BETS_HISTORY
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=GAME_PHASE_DATA
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=MONETARY
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=MONETARY_CONVERSION
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=DESCRIPTIONS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=LANGUAGES
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=LANG_MESSAGES
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=JACKPOT_CLIENTS
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    #TABLE_NAME=JACKPOT_PHASE_DATA
    #fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    #fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
            
    #prepisemo se vrednosti generatorjev
    fbcopy d sysdba:masteraloha@$BKPDB sysdba:masteraloha@/data/ROULETTE_DATA.GDB|grep "G:GEN_"|fbcopy C sysdba:masteraloha@$BKPDB sysdba:masteraloha@/data/ROULETTE_DATA.GDB
    
    #naredimo backup & restore nove baze
    /opt/firebird/bin/gfix -sh -force 0 /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -v /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -v -f /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -mend /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gbak -b -g /ROULETTE_DATA.GDB "/data/TEMPBKP.GBK" -user sysdba -password masteraloha
    rm /data/ROULETTE_DATA.TMP -rf > /dev/null 2>&1
    /opt/firebird/bin/gbak -c -rep "/data/TEMPBKP.GBK" /data/ROULETTE_DATA.TMP -user sysdba -password masteraloha
    mv /data/ROULETTE_DATA.TMP /data/ROULETTE_DATA.GDB -f
    /opt/firebird/bin/gfix -online /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    rm -rf /data/TEMPBKP.GBK > /dev/null 2>&1 

#fi
echo
echo "DB REPAIR LEVEL2 was finished successfully."
echo
sleep 5
exit 0

