#!/bin/bash

UPDATE_NAME="ReplaceMainDB1"

sleep 5
/sbin/service firebird stop
sleep 5
killall fbserver


BKPDB="/data/ROULETTE_DATA_"$UPDATE_NAME"_BKP.GDB";
if [ ! -e $BKPDB ]; then
    mv /data/ROULETTE_DATA.GDB $BKPDB
    cp /RouletteMaster/EMPTY_DATABASE/ROULETTE_NEW.GDB /data/ROULETTE_DATA.GDB
    chmod 666 /data/ROULETTE_DATA.GDB
    chown firebird:firebird /data/ROULETTE_DATA.GDB
    
    /sbin/service firebird start
    sleep 5                       
    
    TABLE_NAME=DIGITAL_COUNTERS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=CONFIGURATION
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=CREDIT_TRANSFERS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=BETS_HISTORY
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=GAME_PHASE_DATA
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=MONETARY
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=MONETARY_CONVERSION
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=DESCRIPTIONS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=LANGUAGES
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=LANG_MESSAGES
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=JACKPOT_CLIENTS
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
    TABLE_NAME=JACKPOT_PHASE_DATA
    fbexport -X -D /ROULETTE_DATA.GDB -p masteraloha -q "delete from $TABLE_NAME"
    fbexport -S -D $BKPDB -P masteraloha -V $TABLE_NAME -F - | fbexport -I -D /ROULETTE_DATA.GDB -P masteraloha -V $TABLE_NAME -F - -R
            
    #prepisemo se vrednosti generatorjev
    fbcopy d sysdba:masteraloha@$BKPDB sysdba:masteraloha@/data/ROULETTE_DATA.GDB|grep "G:GEN_"|fbcopy C sysdba:masteraloha@$BKPDB sysdba:masteraloha@/data/ROULETTE_DATA.GDB
    
    #naredimo backup & restore nove baze
    /opt/firebird/bin/gfix -sh -force 0 /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -v /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -v -f /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gfix -mend /ROULETTE_DATA.GDB -user sysdba -password masteraloha
    /opt/firebird/bin/gbak -b -g /ROULETTE_DATA.GDB "/data/ROULETTE_DATA_"$UpdateName".gbk" -user sysdba -password masteraloha
    rm /data/ROULETTE_DATA.TMP -rf
    /opt/firebird/bin/gbak -c -rep "/data/ROULETTE_DATA_"$UpdateName".gbk" /data/ROULETTE_DATA.TMP -user sysdba -password masteraloha
    mv /data/ROULETTE_DATA.TMP /data/ROULETTE_DATA.GDB -f
    /opt/firebird/bin/gfix -online /ROULETTE_DATA.GDB -user sysdba -password masteraloha
                                                                                
fi
                                                                                    
