#!/bin/sh

# description: Start/Stop ZeBeDee Server
#
# This file belongs in /etc/init.d where it will be run
# on system startup and shutdown to start the roulettemaster
# This program is used for repairing the database file, every
# bootup.


# This init script contains functions specific for redhat
# and mandrake init scripts.

# Source function library.
. /etc/rc.d/init.d/functions

export CONFIGURATION_FOLDER=/RouletteMaster/RouletteTunnel
export CONFIGURATION_FILE=./ServerConf.tnl
export REP_CONFIGURATION_FILE=./RepetitorTunnel.conf
export PROGRAM_FILENAME=/RouletteMaster/RouletteTunnel/iptunnel


# Check the file is there and is executable.
if [ ! -x $PROGRAM_FILENAME ] 
then
	echo $"$PROGRAM_FILENAME does not exist or it is not an executable" 
	exit 0
fi

start(){
	if [ -n "$(ps -A |grep iptunnel)" ] 
	then
	 	echo $"RouletteTunnel is already running" 
		return 0
	fi
	cd $CONFIGURATION_FOLDER
	$PROGRAM_FILENAME -f $CONFIGURATION_FILE
	$PROGRAM_FILENAME -f $REP_CONFIGURATION_FILE
	RETVAL=$?

#INADYN config
SQL_EXE=/RouletteMaster/sqlexec.sh
if [ -e /RouletteMaster/ROULETTE_NAME ]; then
    ROULETTE_NAME=`cat /RouletteMaster/ROULETTE_NAME`
else
    ROULETTE_NAME=`echo "select RES_STR_VALUE from GET_PARAM('192.168.0.254', 'ROULETTE_NAME', 11)" | $SQL_EXE|head -8|tail -1|sed 's/^M$//'|sed 's/[ ^t]*$//'`
fi
#spodnji ukaz izbrise presledke v imenu rulete
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`
ROULETTE_NAME=`echo ${ROULETTE_NAME/ /}`

#echo ROULETTE_NAME = $ROULETTE_NAME
INADYN_USER=enej.miklavcic@gmail.com
INADYN_PASS=4knh2wbf
INADYN_HOST=$ROULETTE_NAME".servegame.com"
INADYN_BIN=/RouletteMaster/RouletteTunnel/inadyn
echo "Updating hostname $INADYN_HOST"
$INADYN_BIN -u $INADYN_USER -p $INADYN_PASS --dyndns_system default@no-ip.com -a $INADYN_HOST --background --log_file "/RouletteMaster/RouletteTunnel/inadyn.log"

	echo "Using configuration file " $CONFIGURATION_FOLDER/$CONFIGURATION_FILE
	sleep 1
	echo "Done!"
	return $RETVAL
}

stop(){
        if [ -z "$(ps -A |grep iptunnel)" ] 
	then
	 	echo $"RouletteTunnel is not running" 
		return 0
	fi

	echo "Stopping RouletteTunnel"
	killall iptunnel &>/dev/null
	RETVAL=$?
	killall inadyn &>/dev/null
	sleep 1
	echo "Done!"
	return $RETVAL
}

status(){
        if [ -z "$(ps -A |grep iptunnel)" ] 
	then
	 	echo $"RouletteTunnel is stopped" 
		return 0
	else
	 	echo $"RouletteTunnel is running" 
		return 0
	fi
}



# See how we were called.
case "$1" in
  start)
	start
	;;	
  stop) 
	stop
	;;
  restart)
	stop
	start
	;;
  status)
	status
	;;
  *)
	echo $"Usage: $0 {start|stop|restart|status|help}"
	exit 1
esac

exit $RETVAL

