drop procedure J_RELOAD_TO_VALUE;
commit retain;
set term ^ ;
CREATE PROCEDURE J_RELOAD_TO_VALUE(
  VAR_JACKPOT_ID VARCHAR(40) CHARACTER SET WIN1250,
  VAR_TO_VALUE_CENTS BIGINT)
RETURNS(
  RES_RESULT SMALLINT,
  RES_CAPTION VARCHAR(100) CHARACTER SET WIN1250)
AS
DECLARE VARIABLE TMP_JACKPOT_STATUS VARCHAR(10);
DECLARE VARIABLE TMP_POT_VALUE NUMERIC(18, 6);
DECLARE VARIABLE TMP_DAY SMALLINT;
DECLARE VARIABLE TMP_MONTH SMALLINT;
DECLARE VARIABLE TMP_YEAR SMALLINT;
DECLARE VARIABLE TMP_HOUR SMALLINT;
DECLARE VARIABLE TMP_MINUTE SMALLINT;
DECLARE VARIABLE TMP_NEW_JACKPOT_ID VARCHAR(40);
DECLARE VARIABLE TMP_RESULT SMALLINT;
DECLARE VARIABLE TMP_PARAM_NAME VARCHAR(40);
DECLARE VARIABLE TMP_RELOAD_CENTS INTEGER;
DECLARE VARIABLE TMP_POT_RELOAD_INIT_CENTS INTEGER;
BEGIN
  /* Procedure body */

  if ( VAR_JACKPOT_ID is null or
       VAR_TO_VALUE_CENTS is null
  ) then
  begin
       RES_RESULT = -1;
       RES_CAPTION = 'Invalid input parameters';
       suspend;
       exit;
  end

  /* configuration default values */
  TMP_DAY = extract(day from current_timestamp);
  TMP_MONTH = extract(month from current_timestamp);
  TMP_YEAR = extract(year from current_timestamp);
  TMP_HOUR = extract(hour from current_timestamp);
  TMP_MINUTE = extract(minute from current_timestamp);

  TMP_NEW_JACKPOT_ID = :VAR_JACKPOT_ID||'_'||:TMP_DAY||'-'||:TMP_MONTH||'-'||:TMP_YEAR||'_'||:TMP_HOUR||':'||TMP_MINUTE;

  select STATUS, POT_VALUE_MONEY, POT_RELOAD_MONEY*100
  from JACKPOT_PHASE_DATA
  where JACKPOT_ID=:VAR_JACKPOT_ID
  into :TMP_JACKPOT_STATUS,
       :TMP_POT_VALUE,
       :TMP_RELOAD_CENTS;
  if ( TMP_JACKPOT_STATUS is null or ('WIN' <> TMP_JACKPOT_STATUS)) then
  begin
      update JACKPOT_PHASE_DATA
      set DESCRIPTION = 'Jackpot was reset with no winner!',
          STATUS = 'NO_WIN',
          JACKPOT_ID = :TMP_NEW_JACKPOT_ID,
          LAST_UPDATE = current_timestamp
      where JACKPOT_ID = :VAR_JACKPOT_ID;
  end else begin
      update JACKPOT_PHASE_DATA
      set STATUS = 'COMPLETED',/* DESCRIPTION je e zapisan ob dolo�tvi winner-ja */
          JACKPOT_ID = :TMP_NEW_JACKPOT_ID,
          LAST_UPDATE = current_timestamp
      where JACKPOT_ID = :VAR_JACKPOT_ID;
      --execute procedure INC_DIGITAL_CNT(:VAR_JACKPOT_ID, 7, (:TMP_POT_VALUE*100)); --stevec vsote izplacanega denarja preko jackpot-a
      --execute procedure INC_DIGITAL_CNT(:VAR_JACKPOT_ID, 8, 1); --stevec jackpot-ov
  end


  update JACKPOT_CLIENTS
  set   JACKPOT_ID = :TMP_NEW_JACKPOT_ID
  where JACKPOT_ID = :VAR_JACKPOT_ID;

  /*za�emo novi jackpot*/
   select RES_NUM_VALUE
   from GET_PARAM('192.168.0.0', 'J_'||:VAR_JACKPOT_ID||'_POT_RELOAD_INIT_CENTS', 11)
   into :TMP_POT_RELOAD_INIT_CENTS;
   if (TMP_POT_RELOAD_INIT_CENTS is null) then
   begin
       TMP_POT_RELOAD_INIT_CENTS=187;
   end

   if (TMP_RELOAD_CENTS is null) then
   begin
       TMP_RELOAD_CENTS=198;
   end

   insert into JACKPOT_PHASE_DATA
   (
    JACKPOT_ID,
    STATUS,
    POT_VALUE_MONEY,
    LAST_UPDATE,
    DESCRIPTION,
    POT_RELOAD_MONEY
   )values
   (
    :VAR_JACKPOT_ID,
    'RESET',
    :VAR_TO_VALUE_CENTS,
    current_timestamp,
    'Jackpot value was reloaded by request to value '||:VAR_TO_VALUE_CENTS||'.',
    cast (:TMP_POT_RELOAD_INIT_CENTS as float)/cast(100 as float)
   );



  RES_CAPTION = 'Jackpot '||:VAR_JACKPOT_ID||' was reloaded with '||:VAR_TO_VALUE_CENTS||'.';
  RES_RESULT = 0;
  SUSPEND;
END^

set term ; ^
commit retain;


drop procedure LOG_TOTALS_ALL;
commit retain;
SET TERM ^ ;
CREATE PROCEDURE LOG_TOTALS_ALL
RETURNS(
  RES_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  RES_CLIENT_CAPTION VARCHAR(40) CHARACTER SET WIN1250,
  RES_TOTAL_IN NUMERIC(18, 2),
  RES_TOTAL_OUT NUMERIC(18, 2),
  RES_TOTAL_BETS NUMERIC(18, 2),
  RES_TOTAL_WINS NUMERIC(18, 2),
  RES_TOTAL_RES_BETS NUMERIC(18, 2),
  RES_TOTAL_NONRES_BETS NUMERIC(18, 2),
  RES_BILL_IN NUMERIC(18, 2),
  RES_STACKER_TOTAL NUMERIC(18, 2),
  RES_BILLS_IN_STACKER BIGINT,
  RES_COIN_IN NUMERIC(18, 2),
  RES_COIN_OUT NUMERIC(18, 2),
  RES_ELECTRONIC_IN NUMERIC(18, 2),
  RES_ELECTRONIC_OUT NUMERIC(18, 2),
  RES_ELECTRONIC_CASH_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_CASH_OUT_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_RES_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_RES_OUT_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_NONRES_IN_CENTS NUMERIC(18, 2),
  RES_ELECTRONIC_NONRES_OUT_CENTS NUMERIC(18, 2),
  RES_HANDPAY NUMERIC(18, 2),
  RES_BONUS_CASH_IN_CENTS NUMERIC(18, 2),
  RES_BONUS_NONRES_IN_CENTS NUMERIC(18, 2),
  RES_BONUS_OUT NUMERIC(18, 2),
  RES_TICKETS_IN_QTY BIGINT,
  RES_TICKETS_OUT_QTY BIGINT,
  RES_TICKET_IN NUMERIC(18, 2),
  RES_TICKET_OUT NUMERIC(18, 2),
  RES_TICKET_CASH_IN NUMERIC(18, 2),
  RES_TICKET_CASH_OUT NUMERIC(18, 2),
  RES_TICKET_RES_IN NUMERIC(18, 2),
  RES_TICKET_RES_OUT NUMERIC(18, 2),
  RES_TICKET_NONRES_IN NUMERIC(18, 2),
  RES_JACKPOT_WIN NUMERIC(18, 2),
  RES_JACKPOTS_WON BIGINT,
  RES_BET_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_PAYIN_PROFIT_PERCENT VARCHAR(15) CHARACTER SET WIN1250,
  RES_GAMES_PLAYED BIGINT,
  RES_GAMES_WON BIGINT,
  RES_GAMES_LOST BIGINT,
  RES_GAMES_SINCE_POWER_UP BIGINT,
  RES_GAMES_SINCE_DOOR_CLOSE BIGINT,
  RES_POWER_UP_COUNT BIGINT,
  RES_DOOR_CLOSE_COUNT BIGINT)
AS
DECLARE VARIABLE C_COEFF INTEGER;
DECLARE VARIABLE M_COEFF INTEGER;
DECLARE VARIABLE TMP_TOTAL_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_WINS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_RES_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_TOTAL_NONRES_BETS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BILL_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_STACKER_TOTAL NUMERIC(18, 2);
DECLARE VARIABLE TMP_BILLS_IN_STACKER BIGINT;
DECLARE VARIABLE TMP_COIN_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_COIN_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_CASH_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_RES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_RES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECTRONIC_NONRES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_HANDPAY NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_BONUS_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKETS_IN_QTY NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKETS_OUT_QTY NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_CASH_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_CASH_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RES_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RES_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_NONRES_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_JACKPOT_WIN NUMERIC(18, 2);
DECLARE VARIABLE TMP_JACKPOTS_WON NUMERIC(18, 2);
DECLARE VARIABLE TMP_GAMES_PLAYED BIGINT;
DECLARE VARIABLE TMP_GAMES_WON BIGINT;
DECLARE VARIABLE TMP_GAMES_LOST BIGINT;
DECLARE VARIABLE TMP_GAMES_SINCE_POWER_UP BIGINT;
DECLARE VARIABLE TMP_GAMES_SINCE_DOOR_CLOSE BIGINT;
DECLARE VARIABLE TMP_POWER_UP_COUNT BIGINT;
DECLARE VARIABLE TMP_DOOR_CLOSE_COUNT BIGINT;
DECLARE VARIABLE TMP_TICKET_RESTRICTED_IN NUMERIC(18, 2);
DECLARE VARIABLE TMP_TICKET_RESTRICTED_OUT NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_CASH_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_CASH_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_RES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_RES_OUT_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_NONRES_IN_CENTS NUMERIC(18, 2);
DECLARE VARIABLE TMP_ELECT_NONRES_OUT_CENTS NUMERIC(18, 2);
BEGIN
select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CURRENCY_TO_CREDIT', 11)
into :M_COEFF;
select RES_NUM_VALUE
from GET_PARAM('192.168.0.0', 'BILL_CREDIT_TO_CURRENCY', 11)
into :C_COEFF;
if (M_COEFF is null or (0=M_COEFF)) then
   M_COEFF = 1;
if (C_COEFF is null or (0=C_COEFF)) then
   C_COEFF = 1;

TMP_TOTAL_IN = 0;
TMP_TOTAL_OUT = 0;
TMP_TOTAL_BETS = 0;
TMP_TOTAL_WINS = 0;
TMP_TOTAL_RES_BETS = 0;
TMP_TOTAL_NONRES_BETS = 0;
TMP_BILL_IN = 0;
TMP_STACKER_TOTAL = 0;
TMP_BILLS_IN_STACKER = 0;
TMP_COIN_IN = 0;
TMP_COIN_OUT = 0;
TMP_ELECTRONIC_IN = 0;
TMP_ELECTRONIC_OUT = 0;
TMP_ELECTRONIC_CASH_IN_CENTS = 0;
TMP_ELECTRONIC_CASH_OUT_CENTS = 0;
TMP_ELECTRONIC_RES_IN_CENTS = 0;
TMP_ELECTRONIC_RES_OUT_CENTS = 0;
TMP_ELECTRONIC_NONRES_IN_CENTS = 0;
TMP_ELECTRONIC_NONRES_OUT_CENTS = 0;
TMP_HANDPAY = 0;
TMP_BONUS_CASH_IN_CENTS = 0;
TMP_BONUS_NONRES_IN_CENTS = 0;
TMP_BONUS_OUT = 0;
TMP_TICKETS_IN_QTY = 0;
TMP_TICKETS_OUT_QTY = 0;
TMP_TICKET_IN = 0;
TMP_TICKET_OUT = 0;
TMP_TICKET_CASH_IN = 0;
TMP_TICKET_CASH_OUT = 0;
TMP_TICKET_RES_IN = 0;
TMP_TICKET_RES_OUT = 0;
TMP_TICKET_NONRES_IN = 0;
TMP_JACKPOT_WIN = 0;
TMP_JACKPOTS_WON = 0;
TMP_GAMES_PLAYED = 0;
TMP_GAMES_WON = 0;
TMP_GAMES_LOST = 0;
TMP_GAMES_SINCE_POWER_UP = 0;
TMP_GAMES_SINCE_DOOR_CLOSE = 0;
TMP_POWER_UP_COUNT = 0;
TMP_DOOR_CLOSE_COUNT = 0;

for select case CLIENT_IP
                when '192.168.0.0' then 'Roulette'
                when '192.168.0.1' then 'Player 1'
                when '192.168.0.2' then 'Player 2'
                when '192.168.0.3' then 'Player 3'
                when '192.168.0.4' then 'Player 4'
                when '192.168.0.5' then 'Player 5'
                when '192.168.0.6' then 'Player 6'
                when '192.168.0.7' then 'Player 7'
                when '192.168.0.8' then 'Player 8'
                when '192.168.0.9' then 'Player 9'
                when '192.168.0.10' then 'Player 10'
                when '192.168.0.11' then 'Player 11'
                when '192.168.0.12' then 'Player 12'
                when '192.168.0.13' then 'Player 13'
                when '192.168.0.14' then 'Player 14'
                when '192.168.0.15' then 'Player 15'
                when '192.168.0.16' then 'Player 16'
                when '192.168.0.17' then 'Player 17'
                when '192.168.0.18' then 'Player 18'
                when '192.168.0.19' then 'Player 19'
                when '192.168.0.20' then 'Player 20'
                when '192.168.0.21' then 'Player 21'
                when '192.168.0.22' then 'Player 22'
                when '192.168.0.23' then 'Player 23'
                when '192.168.0.24' then 'Player 24'
                when '192.168.0.25' then 'Player 25'
                when '192.168.0.26' then 'Player 26'
                when '192.168.0.27' then 'Player 27'
                when '192.168.0.28' then 'Player 28'
                when '192.168.0.29' then 'Player 29'
                when '192.168.0.30' then 'Player 30'
                when '192.168.0.31' then 'Player 31'
                when '192.168.0.32' then 'Player 32'
                when '192.168.0.33' then 'Player 33'
                when '192.168.0.34' then 'Player 34'
                when '192.168.0.35' then 'Player 35'
                when '192.168.0.36' then 'Player 36'
                when '192.168.0.37' then 'Player 37'
                when '192.168.0.38' then 'Player 38'
                when '192.168.0.39' then 'Player 39'
                when '192.168.0.40' then 'Player 40'
                when '192.168.0.41' then 'Player 41'
                when '192.168.0.42' then 'Player 42'
                when '192.168.0.43' then 'Player 43'
                when '192.168.0.44' then 'Player 44'
                when '192.168.0.45' then 'Player 45'
                when '192.168.0.46' then 'Player 46'
                when '192.168.0.47' then 'Player 47'
                when '192.168.0.48' then 'Player 48'
                when '192.168.0.49' then 'Player 49'
                when '192.168.0.50' then 'Player 50'
                else CLIENT_IP
                end as DESCRIPTION,
                case CLIENT_IP
                when '192.168.0.0' then 999/*skupno je zadnji*/
                when '192.168.0.1' then 1
                when '192.168.0.2' then 2
                when '192.168.0.3' then 3
                when '192.168.0.4' then 4
                when '192.168.0.5' then 5
                when '192.168.0.6' then 6
                when '192.168.0.7' then 7
                when '192.168.0.8' then 8
                when '192.168.0.9' then 9
                when '192.168.0.10' then 10
                when '192.168.0.11' then 11
                when '192.168.0.12' then 12
                when '192.168.0.13' then 13
                when '192.168.0.14' then 14
                when '192.168.0.15' then 15
                when '192.168.0.16' then 16
                when '192.168.0.17' then 17
                when '192.168.0.18' then 18
                when '192.168.0.19' then 19
                when '192.168.0.20' then 20
                when '192.168.0.21' then 21
                when '192.168.0.22' then 22
                when '192.168.0.23' then 23
                when '192.168.0.24' then 24
                when '192.168.0.25' then 25
                when '192.168.0.26' then 26
                when '192.168.0.27' then 27
                when '192.168.0.28' then 28
                when '192.168.0.29' then 29
                when '192.168.0.30' then 30
                when '192.168.0.31' then 31
                when '192.168.0.32' then 32
                when '192.168.0.33' then 33
                when '192.168.0.34' then 34
                when '192.168.0.35' then 35
                when '192.168.0.36' then 36
                when '192.168.0.37' then 37
                when '192.168.0.38' then 38
                when '192.168.0.39' then 39
                when '192.168.0.40' then 40
                when '192.168.0.41' then 41
                when '192.168.0.42' then 42
                when '192.168.0.43' then 43
                when '192.168.0.44' then 44
                when '192.168.0.45' then 45
                when '192.168.0.46' then 46
                when '192.168.0.47' then 47
                when '192.168.0.48' then 48
                when '192.168.0.49' then 49
                when '192.168.0.50' then 50
                else 51/*po potrebi dodaj - tale STATION NUMBER SE UPORABLJA SAMO ZA SORTIRANJE, ker STRING SE SORTIRA Player 1, Player 10, Player 11, Player 2,...*/
           end as STATION_NUMBER,
           CLIENT_IP
    from DIGITAL_COUNTERS
    group by CLIENT_IP
    order by 2 ascending, CLIENT_IP ASCENDING
    into :RES_CLIENT_CAPTION,
         :RES_TOTAL_IN, --tega ne rabimo, gre v zacasno spremenljivko
         :RES_CLIENT_IP
do begin
   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 51)
   into RES_TOTAL_IN;
   TMP_TOTAL_IN = TMP_TOTAL_IN+RES_TOTAL_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 52)
   into RES_TOTAL_OUT;
   TMP_TOTAL_OUT = TMP_TOTAL_OUT+RES_TOTAL_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 53)
   into RES_TOTAL_BETS;
   TMP_TOTAL_BETS = TMP_TOTAL_BETS+RES_TOTAL_BETS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 54)
   into RES_TOTAL_WINS;
   TMP_TOTAL_WINS = TMP_TOTAL_WINS+RES_TOTAL_WINS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 55)
       into RES_TOTAL_RES_BETS;
       TMP_TOTAL_RES_BETS = TMP_TOTAL_RES_BETS+RES_TOTAL_RES_BETS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 56)
       into RES_TOTAL_NONRES_BETS;
       TMP_TOTAL_NONRES_BETS = TMP_TOTAL_NONRES_BETS+RES_TOTAL_NONRES_BETS;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 322)
   into RES_BILL_IN;
   TMP_BILL_IN = TMP_BILL_IN+RES_BILL_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 321)
   into RES_STACKER_TOTAL;
   TMP_STACKER_TOTAL = TMP_STACKER_TOTAL+RES_STACKER_TOTAL;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 320)
   into RES_BILLS_IN_STACKER;
   TMP_BILLS_IN_STACKER = TMP_BILLS_IN_STACKER+RES_BILLS_IN_STACKER;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 400)
   into RES_COIN_IN;
   TMP_COIN_IN = TMP_COIN_IN+RES_COIN_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 401)
   into RES_COIN_OUT;
   TMP_COIN_OUT = TMP_COIN_OUT+RES_COIN_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 500)
   into RES_ELECTRONIC_IN;
   TMP_ELECTRONIC_IN = TMP_ELECTRONIC_IN+RES_ELECTRONIC_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 501)
   into RES_ELECTRONIC_OUT;
   TMP_ELECTRONIC_OUT = TMP_ELECTRONIC_OUT+RES_ELECTRONIC_OUT;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 505)
       into RES_ELECTRONIC_CASH_IN_CENTS;
       TMP_ELECTRONIC_CASH_IN_CENTS = TMP_ELECTRONIC_CASH_IN_CENTS+RES_ELECTRONIC_CASH_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 506)
       into RES_ELECTRONIC_CASH_OUT_CENTS;
       TMP_ELECTRONIC_CASH_OUT_CENTS = TMP_ELECTRONIC_CASH_OUT_CENTS+RES_ELECTRONIC_CASH_OUT_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 509)
       into RES_ELECTRONIC_RES_IN_CENTS;
       TMP_ELECTRONIC_RES_IN_CENTS = TMP_ELECTRONIC_RES_IN_CENTS+RES_ELECTRONIC_RES_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 510)
       into RES_ELECTRONIC_RES_OUT_CENTS;
       TMP_ELECTRONIC_RES_OUT_CENTS = TMP_ELECTRONIC_RES_OUT_CENTS+RES_ELECTRONIC_RES_OUT_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 513)
       into RES_ELECTRONIC_NONRES_IN_CENTS;
       TMP_ELECTRONIC_NONRES_IN_CENTS = TMP_ELECTRONIC_NONRES_IN_CENTS+RES_ELECTRONIC_NONRES_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 514)
       into RES_ELECTRONIC_NONRES_OUT_CENTS;
       TMP_ELECTRONIC_NONRES_OUT_CENTS = TMP_ELECTRONIC_NONRES_OUT_CENTS+RES_ELECTRONIC_NONRES_OUT_CENTS;

       select RES_COUNTER_VALUE
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 600)
       into RES_TICKETS_IN_QTY;
       TMP_TICKETS_IN_QTY = TMP_TICKETS_IN_QTY+RES_TICKETS_IN_QTY;

       select RES_COUNTER_VALUE
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 601)
       into RES_TICKETS_OUT_QTY;
       TMP_TICKETS_OUT_QTY = TMP_TICKETS_OUT_QTY+RES_TICKETS_OUT_QTY;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 609)
       into RES_TICKET_CASH_IN;
       TMP_TICKET_CASH_IN = TMP_TICKET_CASH_IN+RES_TICKET_CASH_IN;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 610)
       into RES_TICKET_CASH_OUT;
       TMP_TICKET_CASH_OUT = TMP_TICKET_CASH_OUT+RES_TICKET_CASH_OUT;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 615)
       into RES_TICKET_RES_IN;
       TMP_TICKET_RES_IN = TMP_TICKET_RES_IN+RES_TICKET_RES_IN;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 616)
       into RES_TICKET_RES_OUT;
       TMP_TICKET_RES_OUT = TMP_TICKET_RES_OUT+RES_TICKET_RES_OUT;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 617)
       into RES_TICKET_NONRES_IN;
       TMP_TICKET_NONRES_IN = TMP_TICKET_NONRES_IN+RES_TICKET_NONRES_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 504)
   into RES_HANDPAY;
   TMP_HANDPAY = TMP_HANDPAY+RES_HANDPAY;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 557)
       into RES_BONUS_CASH_IN_CENTS;
       TMP_BONUS_CASH_IN_CENTS = TMP_BONUS_CASH_IN_CENTS+RES_BONUS_CASH_IN_CENTS;

       select (RES_COUNTER_VALUE*1)/cast(100 as numeric(18,4))/*tevec teje v centih*/
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 559)
       into RES_BONUS_NONRES_IN_CENTS;
       TMP_BONUS_NONRES_IN_CENTS = TMP_BONUS_NONRES_IN_CENTS+RES_BONUS_NONRES_IN_CENTS;

       select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
       from GET_DIGITAL_CNT(:RES_CLIENT_IP, 561)
       into RES_BONUS_OUT;
       TMP_BONUS_OUT = TMP_BONUS_OUT+RES_BONUS_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 602)
   into RES_TICKET_IN;
   TMP_TICKET_IN = TMP_TICKET_IN+RES_TICKET_IN;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 603)
   into RES_TICKET_OUT;
   TMP_TICKET_OUT = TMP_TICKET_OUT+RES_TICKET_OUT;

   select (RES_COUNTER_VALUE*:M_COEFF)/cast(:C_COEFF as numeric(18,4))
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 517)
   into RES_JACKPOT_WIN;
   TMP_JACKPOT_WIN = TMP_JACKPOT_WIN+RES_JACKPOT_WIN;

   select RES_COUNTER_VALUE/*tevec teje kolikokrat se je jackpot zgodil*/
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 518)
   into RES_JACKPOTS_WON;
   TMP_JACKPOTS_WON = TMP_JACKPOTS_WON+RES_JACKPOTS_WON;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 300)
   into RES_GAMES_PLAYED;
   TMP_GAMES_PLAYED = TMP_GAMES_PLAYED+RES_GAMES_PLAYED;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 301)
   into RES_GAMES_WON;
   TMP_GAMES_WON = TMP_GAMES_WON+RES_GAMES_WON;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 302)
   into RES_GAMES_LOST;
   TMP_GAMES_LOST = TMP_GAMES_LOST+RES_GAMES_LOST;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 303)
   into RES_GAMES_SINCE_POWER_UP;
   TMP_GAMES_SINCE_POWER_UP = TMP_GAMES_SINCE_POWER_UP+RES_GAMES_SINCE_POWER_UP;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 304)
   into RES_GAMES_SINCE_DOOR_CLOSE;
   TMP_GAMES_SINCE_DOOR_CLOSE = TMP_GAMES_SINCE_DOOR_CLOSE+RES_GAMES_SINCE_DOOR_CLOSE;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 305)
   into RES_POWER_UP_COUNT;
   TMP_POWER_UP_COUNT = TMP_POWER_UP_COUNT+RES_POWER_UP_COUNT;

   select RES_COUNTER_VALUE
   from GET_DIGITAL_CNT(:RES_CLIENT_IP, 306)
   into RES_DOOR_CLOSE_COUNT;
   TMP_DOOR_CLOSE_COUNT = TMP_DOOR_CLOSE_COUNT+RES_DOOR_CLOSE_COUNT;

   if ( RES_TOTAL_BETS is not null and RES_TOTAL_BETS <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_TOTAL_BETS-RES_TOTAL_WINS)*100/RES_TOTAL_BETS as numeric(13,2))as varchar(13)) || ' %';
   else
       RES_BET_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_TOTAL_IN-RES_TOTAL_OUT)*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

   suspend;
end

RES_CLIENT_IP = '192.168.0.0';
RES_CLIENT_CAPTION = 'All Players';
RES_TOTAL_IN = TMP_TOTAL_IN;
RES_TOTAL_OUT = TMP_TOTAL_OUT;
RES_TOTAL_BETS = TMP_TOTAL_BETS;
RES_TOTAL_WINS = TMP_TOTAL_WINS;
RES_TOTAL_RES_BETS = TMP_TOTAL_RES_BETS;
RES_TOTAL_NONRES_BETS = TMP_TOTAL_NONRES_BETS;
RES_BILL_IN = TMP_BILL_IN;
RES_STACKER_TOTAL = TMP_STACKER_TOTAL;
RES_BILLS_IN_STACKER = TMP_BILLS_IN_STACKER;
RES_COIN_IN = TMP_COIN_IN;
RES_COIN_OUT = TMP_COIN_OUT;
RES_ELECTRONIC_IN = TMP_ELECTRONIC_IN;
RES_ELECTRONIC_OUT = TMP_ELECTRONIC_OUT;
RES_ELECTRONIC_CASH_IN_CENTS = TMP_ELECTRONIC_CASH_IN_CENTS;
RES_ELECTRONIC_CASH_OUT_CENTS = TMP_ELECTRONIC_CASH_OUT_CENTS;
RES_ELECTRONIC_RES_IN_CENTS = TMP_ELECTRONIC_RES_IN_CENTS;
RES_ELECTRONIC_RES_OUT_CENTS = TMP_ELECTRONIC_RES_OUT_CENTS;
RES_ELECTRONIC_NONRES_IN_CENTS = TMP_ELECTRONIC_NONRES_IN_CENTS;
RES_ELECTRONIC_NONRES_OUT_CENTS = TMP_ELECTRONIC_NONRES_OUT_CENTS;
RES_HANDPAY = TMP_HANDPAY;
RES_BONUS_CASH_IN_CENTS = TMP_BONUS_CASH_IN_CENTS;
RES_BONUS_NONRES_IN_CENTS = TMP_BONUS_NONRES_IN_CENTS;
RES_BONUS_OUT = TMP_BONUS_OUT;
RES_TICKETS_IN_QTY = TMP_TICKETS_IN_QTY;
RES_TICKETS_OUT_QTY = TMP_TICKETS_OUT_QTY;
RES_TICKET_IN = TMP_TICKET_IN;
RES_TICKET_OUT = TMP_TICKET_OUT;
RES_TICKET_CASH_IN = TMP_TICKET_CASH_IN;
RES_TICKET_CASH_OUT = TMP_TICKET_CASH_OUT;
RES_TICKET_RES_IN = TMP_TICKET_RES_IN;
RES_TICKET_RES_OUT = TMP_TICKET_RES_OUT;
RES_TICKET_NONRES_IN = TMP_TICKET_NONRES_IN;
RES_JACKPOT_WIN = TMP_JACKPOT_WIN;
RES_JACKPOTS_WON = TMP_JACKPOTS_WON;
RES_GAMES_PLAYED = TMP_GAMES_PLAYED;
RES_GAMES_WON = TMP_GAMES_WON;
RES_GAMES_LOST = TMP_GAMES_LOST;
RES_GAMES_SINCE_POWER_UP = TMP_GAMES_SINCE_POWER_UP;
RES_GAMES_SINCE_DOOR_CLOSE = TMP_GAMES_SINCE_DOOR_CLOSE;
RES_POWER_UP_COUNT = TMP_POWER_UP_COUNT;
RES_DOOR_CLOSE_COUNT = TMP_DOOR_CLOSE_COUNT;

   if ( RES_TOTAL_BETS is not null and RES_TOTAL_BETS <> 0 ) then
      RES_BET_PROFIT_PERCENT = cast(cast((RES_TOTAL_BETS-RES_TOTAL_WINS)*100/RES_TOTAL_BETS as numeric(13,2))as varchar(13)) || ' %';
   else
       RES_BET_PROFIT_PERCENT ='0,00 %';

   if ( RES_TOTAL_IN is not null and RES_TOTAL_IN <> 0 ) then
      RES_PAYIN_PROFIT_PERCENT = cast(cast((RES_TOTAL_IN-RES_TOTAL_OUT)*100/RES_TOTAL_IN as numeric(13,2))as varchar(13)) || ' %';
   else
      RES_PAYIN_PROFIT_PERCENT ='0,00 %';

SUSPEND;
END^

SET TERM ; ^

commit retain;


drop procedure J_RELOAD_TO_VALUE;
commit retain;

SET TERM ^ ;
CREATE PROCEDURE J_RELOAD_TO_VALUE(
  VAR_JACKPOT_ID VARCHAR(40) CHARACTER SET WIN1250,
  VAR_TO_VALUE_CENTS BIGINT)
RETURNS(
  RES_RESULT SMALLINT,
  RES_CAPTION VARCHAR(100) CHARACTER SET WIN1250)
AS
DECLARE VARIABLE TMP_JACKPOT_STATUS VARCHAR(10);
DECLARE VARIABLE TMP_POT_VALUE NUMERIC(18, 6);
DECLARE VARIABLE TMP_DAY SMALLINT;
DECLARE VARIABLE TMP_MONTH SMALLINT;
DECLARE VARIABLE TMP_YEAR SMALLINT;
DECLARE VARIABLE TMP_HOUR SMALLINT;
DECLARE VARIABLE TMP_MINUTE SMALLINT;
DECLARE VARIABLE TMP_NEW_JACKPOT_ID VARCHAR(40);
DECLARE VARIABLE TMP_RESULT SMALLINT;
DECLARE VARIABLE TMP_PARAM_NAME VARCHAR(40);
DECLARE VARIABLE TMP_RELOAD_CENTS INTEGER;
DECLARE VARIABLE TMP_POT_RELOAD_INIT_CENTS INTEGER;
BEGIN
  /* Procedure body */

  if ( VAR_JACKPOT_ID is null or
       VAR_TO_VALUE_CENTS is null
  ) then
  begin
       RES_RESULT = -1;
       RES_CAPTION = 'Invalid input parameters';
       suspend;
       exit;
  end

  /* configuration default values */
  TMP_DAY = extract(day from current_timestamp);
  TMP_MONTH = extract(month from current_timestamp);
  TMP_YEAR = extract(year from current_timestamp);
  TMP_HOUR = extract(hour from current_timestamp);
  TMP_MINUTE = extract(minute from current_timestamp);

  TMP_NEW_JACKPOT_ID = :VAR_JACKPOT_ID||'_'||:TMP_DAY||'-'||:TMP_MONTH||'-'||:TMP_YEAR||'_'||:TMP_HOUR||':'||TMP_MINUTE;

  select STATUS, POT_VALUE_MONEY, POT_RELOAD_MONEY*100
  from JACKPOT_PHASE_DATA
  where JACKPOT_ID=:VAR_JACKPOT_ID
  into :TMP_JACKPOT_STATUS,
       :TMP_POT_VALUE,
       :TMP_RELOAD_CENTS;
  if ( TMP_JACKPOT_STATUS is null or ('WIN' <> TMP_JACKPOT_STATUS)) then
  begin
      update JACKPOT_PHASE_DATA
      set DESCRIPTION = 'Jackpot was reset with no winner!',
          STATUS = 'NO_WIN',
          JACKPOT_ID = :TMP_NEW_JACKPOT_ID,
          LAST_UPDATE = current_timestamp
      where JACKPOT_ID = :VAR_JACKPOT_ID;
  end else begin
      update JACKPOT_PHASE_DATA
      set STATUS = 'COMPLETED',/* DESCRIPTION je e zapisan ob dolo�tvi winner-ja */
          JACKPOT_ID = :TMP_NEW_JACKPOT_ID,
          LAST_UPDATE = current_timestamp
      where JACKPOT_ID = :VAR_JACKPOT_ID;
      --execute procedure INC_DIGITAL_CNT(:VAR_JACKPOT_ID, 7, (:TMP_POT_VALUE*100)); --stevec vsote izplacanega denarja preko jackpot-a
      --execute procedure INC_DIGITAL_CNT(:VAR_JACKPOT_ID, 8, 1); --stevec jackpot-ov
  end


  update JACKPOT_CLIENTS
  set   JACKPOT_ID = :TMP_NEW_JACKPOT_ID
  where JACKPOT_ID = :VAR_JACKPOT_ID;

  /*za�emo novi jackpot*/
   select RES_NUM_VALUE
   from GET_PARAM('192.168.0.0', 'J_'||:VAR_JACKPOT_ID||'_POT_RELOAD_INIT_CENTS', 11)
   into :TMP_POT_RELOAD_INIT_CENTS;
   if (TMP_POT_RELOAD_INIT_CENTS is null) then
   begin
       TMP_POT_RELOAD_INIT_CENTS=187;
   end

   if (TMP_RELOAD_CENTS is null) then
   begin
       TMP_RELOAD_CENTS=198;
   end

   insert into JACKPOT_PHASE_DATA
   (
    JACKPOT_ID,
    STATUS,
    POT_VALUE_MONEY,
    LAST_UPDATE,
    DESCRIPTION,
    POT_RELOAD_MONEY
   )values
   (
    :VAR_JACKPOT_ID,
    'RESET',
    :VAR_TO_VALUE_CENTS,
    current_timestamp,
    'Jackpot value was reloaded by request to value '||:VAR_TO_VALUE_CENTS||'.',
    cast (:TMP_POT_RELOAD_INIT_CENTS as float)/cast(100 as float)
   );



  RES_CAPTION = 'Jackpot '||:VAR_JACKPOT_ID||' was reloaded with '||:VAR_TO_VALUE_CENTS||'.';
  RES_RESULT = 0;
  SUSPEND;
END^

SET TERM ; ^
commit retain;

ALTER TABLE BETS_HISTORY
ADD X25Y9 T_CREDIT,
ADD X25Y10 T_CREDIT,
ADD X24Y9 T_CREDIT,
ADD X24Y10 T_CREDIT,
ADD X23Y9 T_CREDIT,
ADD X23Y10 T_CREDIT,
ADD X22Y9 T_CREDIT,
ADD X22Y10 T_CREDIT,
ADD X21Y9 T_CREDIT,
ADD X21Y10 T_CREDIT,
ADD X20Y9 T_CREDIT,
ADD X20Y10 T_CREDIT,
ADD X19Y9 T_CREDIT,
ADD X19Y10 T_CREDIT,
ADD X18Y9 T_CREDIT,
ADD X18Y10 T_CREDIT,
ADD X17Y9 T_CREDIT,
ADD X17Y10 T_CREDIT,
ADD X16Y9 T_CREDIT,
ADD X16Y10 T_CREDIT,
ADD X15Y9 T_CREDIT,
ADD X15Y10 T_CREDIT,
ADD X14Y9 T_CREDIT,
ADD X14Y10 T_CREDIT,
ADD X13Y9 T_CREDIT,
ADD X13Y10 T_CREDIT,
ADD X12Y9 T_CREDIT,
ADD X12Y10 T_CREDIT,
ADD X11Y9 T_CREDIT,
ADD X11Y10 T_CREDIT,
ADD X10Y9 T_CREDIT,
ADD X10Y10 T_CREDIT,
ADD X9Y9 T_CREDIT,
ADD X9Y10 T_CREDIT,
ADD X8Y9 T_CREDIT,
ADD X8Y10 T_CREDIT,
ADD X7Y9 T_CREDIT,
ADD X7Y10 T_CREDIT,
ADD X6Y9 T_CREDIT,
ADD X6Y10 T_CREDIT,
ADD X5Y9 T_CREDIT,
ADD X5Y10 T_CREDIT,
ADD X4Y9 T_CREDIT,
ADD X4Y10 T_CREDIT,
ADD X3Y9 T_CREDIT,
ADD X3Y10 T_CREDIT,
ADD X2Y9 T_CREDIT,
ADD X2Y10 T_CREDIT,
ADD X1Y9 T_CREDIT,
ADD X1Y10 T_CREDIT,
ADD X0Y9 T_CREDIT,
ADD X0Y10 T_CREDIT;
commit retain;

--delete from languages where lang_id=24;
update lang_messages set lang_message='220/110V POWER FAILURE. Please do payout. Shutting down after 2 minutes...' where lang_msg_id=103;
insert into LANG_MESSAGES(LANG_MSG_ID, LANG_MSG_SUB_ID, LANG_ID, LANG_MESSAGE)values(80, 0, 11, 'Game error 80. Ball speed was irregular.');
--INSERT INTO LANGUAGES (LANG_ID, LANG_CAPTION, LANG_SOUND_FOLDER, VISIBLE) VALUES (24, 'Chinese', './AUDIO/TW', 0);

commit retain;

set term ^ ;
ALTER PROCEDURE C_MONEY_IN(
  VAR_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  VAR_GAME_ID BIGINT,
  VAR_MONEY_CONVERSION_ID BIGINT,
  VAR_MONEY_VALUE NUMERIC(18, 3),
  VAR_CONFIRM SMALLINT)
RETURNS(
  RESULT BIGINT,
  RES_MONEY_ID BIGINT,
  RES_CREDIT_VALUE BIGINT)
AS
DECLARE VARIABLE TMP_COEFFICIENT DECIMAL(18, 3);
DECLARE VARIABLE TMP BIGINT;
DECLARE VARIABLE TMP_MON_ID BIGINT;
DECLARE VARIABLE TMP_IS_CASHABLE SMALLINT;
DECLARE VARIABLE TMP_CREDIT_VALUE NUMERIC(18, 0);
BEGIN

if ( VAR_CLIENT_IP is null or
     VAR_MONEY_CONVERSION_ID is null or
     VAR_MONEY_VALUE is null or
     VAR_GAME_ID is null or
     VAR_CONFIRM is null ) then
   BEGIN
        RESULT = -1;
        suspend;
        exit;
   END

select MONETARY_CONVERSION.MON_C_COEFFICIENT
from MONETARY_CONVERSION
where MONETARY_CONVERSION.MON_C_ID = :VAR_MONEY_CONVERSION_ID
into :TMP_COEFFICIENT;

if ( TMP_COEFFICIENT is null ) then
   begin
        execute procedure WRITE_LOG('DB',0, 100300, 'WARNING: Playstation ' || :VAR_CLIENT_IP || ' is trying to convert money to credit with MON_C_ID=''' || :VAR_MONEY_CONVERSION_ID || ''' which can not be found.' );
        RESULT = -2;
        RES_CREDIT_VALUE=0;
        RES_MONEY_ID = -1;
        suspend;
        exit;
   end

if ( TMP_COEFFICIENT = 0 ) then
begin
     RESULT = -4;
     RES_CREDIT_VALUE=0;
     RES_MONEY_ID = -1;
     suspend;
     exit;
end

RES_CREDIT_VALUE = TMP_COEFFICIENT * VAR_MONEY_VALUE;
if ( (cast(RES_CREDIT_VALUE as numeric(18,3))/TMP_COEFFICIENT) <> VAR_MONEY_VALUE  ) then
begin
     execute procedure WRITE_LOG('DB',0, 100300, 'ERROR: Playstation ' || :VAR_CLIENT_IP || ' is trying to PAY_IN. Credit value result is not a natural number.' );
     RES_CREDIT_VALUE=0;
     RES_MONEY_ID = -1;
     RESULT = -3;
     suspend;
     exit;
end

RES_MONEY_ID = gen_id(GEN_MONETARY,1);
insert into MONETARY(
       monetary.MON_ID,
       monetary.client_ip,
       monetary.mon_operation_time,
       monetary.mon_operation_type,
       monetary.mon_money_value,
       monetary.mon_credit_value,
       monetary.mon_c_id,
       monetary.game_id,
       monetary.confirmed
       )
       values
       (
       :RES_MONEY_ID,
       :VAR_CLIENT_IP,
       current_timestamp,
       'IN',
       :VAR_MONEY_VALUE,
       :RES_CREDIT_VALUE,
       :VAR_MONEY_CONVERSION_ID,
       :VAR_GAME_ID,
       :VAR_CONFIRM
       );

/* give credits to the client with credit transfer */
if ( 0 <> VAR_CONFIRM ) then
begin
   TMP_IS_CASHABLE = 1-(:VAR_MONEY_CONVERSION_ID-2*(cast(:VAR_MONEY_CONVERSION_ID as BIGINT)/2));

   execute procedure C_CRE_TRANS('MONEY_IN', :VAR_GAME_ID, :RES_MONEY_ID, :VAR_CLIENT_IP, :RES_CREDIT_VALUE, :TMP_IS_CASHABLE)
   returning_values TMP;

   if ( TMP_IS_CASHABLE <> 0 ) then
   begin --cashable credits
--     execute procedure inc_digital_cnt(:VAR_CLIENT_IP,'LIFE_COUNTER_IN', :RES_CREDIT_VALUE);
     execute procedure WRITE_LOG('DB',:VAR_GAME_ID, 100300, 'INFO:Playboard '||:VAR_CLIENT_IP || ' PAYED-IN ' || :RES_CREDIT_VALUE || ' cash credits');
   end
   else
   begin --playable credits
--     execute procedure inc_digital_cnt(:VAR_CLIENT_IP,'LIFE_COUNTER_IN_PLAY', :RES_CREDIT_VALUE);
     execute procedure WRITE_LOG('DB',:VAR_GAME_ID, 100300, 'INFO:Playboard '||:VAR_CLIENT_IP || ' PAYED-IN ' || :RES_CREDIT_VALUE || ' play credits');
   end
   RESULT = 0;
end
else
begin
     RESULT = RES_MONEY_ID;
end

/*
select GET_NEXT_ID.VAR_NEXT_ID
from GET_NEXT_ID('CREDIT_TRANSFERS')
into :tmp_credit_transfers_id;

if ( tmp_credit_transfers_id is null ) then
   begin
        RES_CREDIT_VALUE = -3;
        suspend;
        exit;
   end
insert into CREDIT_TRANSFERS(
       CREDIT_TRANSFERS.CT_ID,
       CREDIT_TRANSFERS.GAME_ID,
       CREDIT_TRANSFERS.CLIENT_IP,
       CREDIT_TRANSFERS.FROM_IP,
       CREDIT_TRANSFERS.TO_IP,
       CREDIT_TRANSFERS.CREDIT_VALUE,
       CREDIT_TRANSFERS.IS_CACHABLE,
       CREDIT_TRANSFERS.TIME_STAMP
       )
       values
       (
       :tmp_credit_transfers_id,
       :VAR_GAME_ID,
       :RES_MONEY_ID,
       'MONEY_IN',
       :VAR_CLIENT_IP,
       :RES_CREDIT_VALUE,
       1-(:VAR_MONEY_CONVERSION_ID-2*(cast(:VAR_MONEY_CONVERSION_ID as BIGINT)/2)),
       current_timestamp
       );

*/
  /* Procedure body */
  SUSPEND;
END; ^

set term ; ^

set term ^ ;

ALTER PROCEDURE DB_SERVICE
AS
DECLARE VARIABLE TMP_GAME_ID BIGINT;
DECLARE VARIABLE INDEX_NAME VARCHAR(31);
BEGIN

     /* delete all the data of games older than last 10000 */
     select gen_id(GEN_GAME_ID, 0)
     from rdb$database
     into :TMP_GAME_ID;
     if ( (TMP_GAME_ID-10000)<0 ) then
        TMP_GAME_ID = 0;
     else
        TMP_GAME_ID = TMP_GAME_ID-10000;

     --hranimo zadnjih 10000 iger
          delete from BETS_HISTORY
          where BETS_HISTORY.GAME_ID < :TMP_GAME_ID;

     if ( (TMP_GAME_ID-90000)<0 ) then
        TMP_GAME_ID = 0;
     else
        TMP_GAME_ID = TMP_GAME_ID-90000;
     --hranimo zadnjih 100000 iger
          delete from GAME_PHASE_DATA
          where GAME_PHASE_DATA.GAME_ID < :TMP_GAME_ID;

          delete from CREDIT_TRANSFERS
          where CREDIT_TRANSFERS.GAME_ID < :TMP_GAME_ID
          and   CREDIT_TRANSFERS.ct_id>0;

          delete from MONETARY
          where MONETARY.GAME_ID < :TMP_GAME_ID
          and   MONETARY.GAME_ID > 10
          and   MONETARY.mon_id > 0;

          delete from LOG
          where (((log.GAME_ID < :TMP_GAME_ID) and (log.GAME_ID > 10)) or (log.LOG_TIME < CURRENT_DATE-180))
          and log.log_id>=0;

     /* delete all the data of slot games older than last 10000 */
     select gen_id(GEN_SLOT_GAME_DATA, 0)
     from rdb$database
     into :TMP_GAME_ID;
     if ( (TMP_GAME_ID-5000)<0 ) then
        TMP_GAME_ID = 0;
     else
        TMP_GAME_ID = TMP_GAME_ID-5000;

     delete from SLOT_GAME_DATA
     where SLOT_GAME_DATA.SGD_ID < :TMP_GAME_ID;

     /* recalculate ALL indices */
     for select RDB$INDEX_NAME from RDB$INDICES into :index_name do
     execute statement 'SET statistics INDEX ' || :index_name || ';';

  SUSPEND;
END; ^

set term ; ^

set term ^ ;

ALTER PROCEDURE INC_DIGITAL_CNT(
  VAR_CLIENT_IP VARCHAR(15) CHARACTER SET WIN1250,
  VAR_COUNTER_INDEX INTEGER,
  VAR_INCREMENT_VALUE BIGINT)
AS
DECLARE VARIABLE TMP_COUNTER_VALUE BIGINT;
DECLARE VARIABLE TMP_MAX_VALUE BIGINT;
DECLARE VARIABLE TMP_OVERFLOW_VALUE BIGINT;
BEGIN
if ( VAR_CLIENT_IP is null or
     VAR_COUNTER_INDEX is null or
     VAR_INCREMENT_VALUE is null
    ) then
    begin
         execute procedure WRITE_LOG('DB', 0, 101400, 'ERROR: Trying to increment counter, with invalid input parameters. Nothing done.');
         suspend;
         exit;
    end

         /* INCREMENT COUNTER FOR THE CLIENT */
         tmp_counter_value=NULL;
         select DIGITAL_COUNTERS.counter_value
         from DIGITAL_COUNTERS
         where DIGITAL_COUNTERS.client_ip = :VAR_CLIENT_IP
         and   DIGITAL_COUNTERS.counter_index = :VAR_COUNTER_INDEX
         into :tmp_counter_value;

         if ( tmp_counter_value is null ) then
         begin
              tmp_counter_value=0;
              insert into DIGITAL_COUNTERS(
              CLIENT_IP,
              COUNTER_INDEX,
              COUNTER_VALUE,
              COUNTING_FROM
              )
              values
              (
              :VAR_CLIENT_IP,
              :VAR_COUNTER_INDEX,
              :tmp_counter_value,
              current_timestamp
              );
         end

         TMP_MAX_VALUE=999999999999; --zadnja vrednost stevca(TMP_MAX_VALUE+1 = 0)
         if ( (TMP_MAX_VALUE-VAR_INCREMENT_VALUE)<tmp_counter_value ) then
         begin --prislo bo do obrata digitalnih stevcev
              VAR_INCREMENT_VALUE = VAR_INCREMENT_VALUE-(TMP_MAX_VALUE-tmp_counter_value)-1; --odstejemo vrednost do obrata
              tmp_counter_value=0; --zacnemo pri nic, ker smo odsteli vrednost do obrata
         end

         tmp_counter_value = tmp_counter_value+VAR_INCREMENT_VALUE;

         update DIGITAL_COUNTERS
         set    DIGITAL_COUNTERS.counter_value = :tmp_counter_value
         where  DIGITAL_COUNTERS.client_ip = :VAR_CLIENT_IP
         and    DIGITAL_COUNTERS.counter_index = :VAR_COUNTER_INDEX;
  SUSPEND;
END; ^

set term ; ^

/*select result from SET_PARAM('192.168.0.0', 'DEFAULT', 'RPC_SRV_RNG1', 'RNG1 RPC Server', '', 11, 0, '192.168.0.254');
select result from SET_PARAM('192.168.0.0', 'DEFAULT', 'RPC_PORT_RNG1', 'RNG1 RPC Port', '', 11, 6666, '6666');
*/
commit work;

