#************************************************************************************
# INSTALL SCRIPT HEADER - just change UpdateName to something not used before...
#************************************************************************************


WORKING_DIR=`pwd`

#preverimo, ali je ta update že nameščen
UpdateName="FIRST_UPDATE_3"
DependsOnUpdateCheckFile="/RouletteMaster/Updates/installed/FIRST_UPDATE/installed"
InstalledUpdatesDir="/RouletteMaster/Updates/installed/"$UpdateName"/"
UpdateLogFileName=$InstalledUpdatesDir"/"$UpdateName".log"

echo "Checking..."
if [ -f $InstalledUpdatesDir"/installed" ]; then 
	echo $UpdateName" is already installed - REINSTALLING."
#	exit 0; #update was already installed
fi;

#preverimo, ali imamo ze nove ip adrese ali ne
ifconfig | grep 10.5.10 > /dev/null
if [ $? -ne 0 ]; then
    #moramo nastaviti IP-je na 192.168.0.254, na novih sistemih, pa ni potrebno, ker imamo ip adreso 10.5.10.X
    echo "select result from SET_PARAM('192.168.0.0', 'DEFAULT', 'RPC_SRV_RNG1', 'RNG1 RPC Server', '', 11, 0, '192.168.0.254');" |/RouletteMaster/sqlexec.sh
    echo "select result from SET_PARAM('192.168.0.0', 'DEFAULT', 'RPC_PORT_RNG1', 'RNG1 RPC Port', '', 11, 6666, '6666');" |/RouletteMaster/sqlexec.sh
fi;

#if [ ! -f $DependsOnUpdateCheckFile ]; then
#	echo "Dependency $DependsOnUpdateCheckFile not met."
#	echo "Install that first."
#	exit 0;#dependeny update not installed
#fi;


echo $UpdateName" pending for install."
echo "Press CTRL+C to cancel now.."
sleep 5

echo "Update process started. Do not interrupt this process..."
echo "Please wait, installing..."
# shinhroniziramo datume datotek s časom na ciljnem sistemu
find . -exec /bin/touch '{}' \; #Recursive touch command

/sbin/service crond stop
/sbin/service roulette stop
/sbin/service addnewpsd stop
sleep 10
/sbin/service roulette kill

#naredimo restore point - backup
echo "Creating backup..."
mkdir -p /data/updates_backup/bkp_$UpdateName 
cp /data/ROULETTE_DATA.GDB /data/updates_backup/bkp_$UpdateName -rf --reply=yes --preserve=all &>/dev/null
cp /RouletteMaster /data/updates_backup/bkp_$UpdateName -rf --reply=yes --preserve=all &>/dev/null
cp /ClientRoot /data/updates_backup/bkp_$UpdateName -rf --reply=yes --preserve=all &>/dev/null
cp /etc /data/updates_backup/bkp_$UpdateName -rf --reply=yes --preserve=all &>/dev/null

#sedaj lahko začnemo spreminjati, ker smo naredili backup ;)
mkdir -p $InstalledUpdatesDir

#naredimo uninstall skripto...
echo "echo" >$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"This will uninstall "$UpdateName" and any later updates.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"ALL DATA, PAY-INs, PAY-OUTs, GAMES,.., made after "$UpdateName"\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"WILL BE LOST. WILL BE LOST. WILL BE LOST.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"NOTE: A roulette restart will be necesary after uninstall.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"Do you want to restore the roulette system to the exact state\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"as before "$UpdateName" was installed?\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \"yes/no\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo \" ! SOME DATA MAY BE LOST ! \""  >>$InstalledUpdatesDir"Uninstall.sh"
echo "echo" >>$InstalledUpdatesDir"Uninstall.sh"
echo "read result" >>$InstalledUpdatesDir"Uninstall.sh"
echo "if [ \"\$result\" = \"yes\" ]; then"  >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"OK. Please wait...\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	/sbin/service crond stop &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	/sbin/service roulette stop &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	/sbin/service addnewpsd stop &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	/sbin/service firebird stop &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	sleep 10" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	cp /data/updates_backup/bkp_"$UpdateName"/ROULETTE_DATA.GDB /data/ROULETTE_DATA.GDB -rf --reply=yes --preserve=all &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	cp /data/updates_backup/bkp_"$UpdateName"/RouletteMaster / -rf --reply=yes --preserve=all &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	cp /data/updates_backup/bkp_"$UpdateName"/ClientRoot / -rf --reply=yes --preserve=all &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	cp /data/updates_backup/bkp_"$UpdateName"/etc / -rf --reply=yes --preserve=all &>/dev/null" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"Success!\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"Please restart the system to make sure everything is in place.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"Enjoy\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "else" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"You answered \"\$result\", which for me means NO.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "	echo \"Bye.\"" >>$InstalledUpdatesDir"Uninstall.sh"
echo "fi;" >>$InstalledUpdatesDir"Uninstall.sh"

chmod 755 $InstalledUpdatesDir"Uninstall.sh"


##izvedemo update database-a, predno ustavimo firebird
#DBUPDATE
if [ -f UPDATE_DB.sql ]; then
    /etc/sysconfig/network-scripts/ifdown eth0; #samo ce je potrebno
    ./update_db.sh
    /etc/sysconfig/network-scripts/ifup eth0; #samo ce je potrebno
fi;

#************************************************************************************
# INSTALL SCRIPT BODY -- write your update commands here
#************************************************************************************
/sbin/service firebird stop
sleep 10

echo -n "Copying ./ROOT to /    ..." >> $UpdateLogFileName
cp ./ROOT/* / -rf --reply=yes --preserve=all >> $UpdateLogFileName
echo "done." >> $UpdateLogFileName

#taiwan, aik, ...
#cp -Rf /ClientRoot/RouletteFiles/tw/* /ClientRoot/RouletteFiles/AGTPLUS/OEM_SKIN2/ 
#mkdir -p /ClientRoot/RouletteFiles/AIK; cp -Rf /ClientRoot/RouletteFiles/aik_agtplus /ClientRoot/RouletteFiles/AIK; cp -P /ClientRoot`cat /ClientRoot/RouletteFiles/working_dir`/Loading.png /ClientRoot/RouletteFiles/AIK/; echo "/RouletteFiles/AIK/" > /ClientRoot/RouletteFiles/working_dir
#mkdir -p /ClientRoot/RouletteFiles/AIK; cp -Rf /ClientRoot/RouletteFiles/aik/* /ClientRoot/RouletteFiles/AIK; cp -P /ClientRoot`cat /ClientRoot/RouletteFiles/working_dir`/Loading.png /ClientRoot/RouletteFiles/AIK/; echo "/RouletteFiles/AIK/" > /ClientRoot/RouletteFiles/working_dir

#update KNOPPIX-a
mkdir /mnt/tmp
mount /dev/sda2 /mnt/tmp
echo -n "Copying ./ROOT_KNOPPIX to /mnt/tmp    ..." >> $UpdateLogFileName
cp ./ROOT_KNOPPIX/* /mnt/tmp -rf --reply=yes --preserve=all >> $UpdateLogFileName
chown 1000:1000 /mnt/tmp/home/knoppix -R
echo "done." >> $UpdateLogFileName
umount /mnt/tmp


#/sbin/service firebird start
#/sbin/service crond start
#/sbin/service roulette start
#/sbin/service addnewpsd start

#************************************************************************************
# INSTALL SCRIPT FOOTER - change command.sh..., and or phone_number
#************************************************************************************
#zapomnimo si, da smo ta update že namestili
echo OK. > $InstalledUpdatesDir"/installed"

#Set this to whatever is needed(SHUTDOWN, RESTART, PLAYBOARDS_RESTART,...)
/RouletteMaster/command.sh "RESTART"


#sporočimo
/RouletteMaster/sendsms.sh 38640333105 "FirstUpdate2 successfull!"

echo Done. >> $UpdateLogFileName
echo $UpdateName" was successfully installed on this system." >> $UpdateLogFileName
echo "Delete "$InstalledUpdatesDir$UpdateName", to reinstall." >> $UpdateLogFileName

init 6

